using Mapster;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SqlSugar;
using Volo.Abp.Application.Dtos;
using Volo.Abp.Application.Services;
using Volo.Abp.Users;
using Yi.Framework.AiHub.Application.Contracts.Dtos;
using Yi.Framework.AiHub.Domain.Entities;
using Yi.Framework.AiHub.Domain.Entities.Chat;
using Yi.Framework.SqlSugarCore.Abstractions;

namespace Yi.Framework.AiHub.Application.Services;

public class MessageService : ApplicationService
{
    private readonly ISqlSugarRepository<MessageAggregateRoot> _repository;

    public MessageService(ISqlSugarRepository<MessageAggregateRoot> repository)
    {
        _repository = repository;
    }

    /// <summary>
    /// 查询消息
    /// 需要会话id
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    [Authorize]
    public async Task<PagedResultDto<MessageDto>> GetListAsync([FromQuery]MessageGetListInput input)
    {
        RefAsync<int> total = 0;
        var userId = CurrentUser.GetId();
        var entities = await _repository._DbQueryable
            .Where(x => x.SessionId == input.SessionId)
            .Where(x=>x.UserId == userId)
            .OrderBy(x => x.Id)
            .ToPageListAsync(input.SkipCount, input.MaxResultCount, total);
        return new PagedResultDto<MessageDto>(total, entities.Adapt<List<MessageDto>>());
    }
}